

#include "atom.h"



atom::atom( const std::string& name )
{
   std::map< std::string, unsigned int > :: const_iterator
      p = string2index. find( name );

   if( p != string2index. end( ))
   {
      index = p -> second;
   }
   else
   {
      string2index. insert( std::pair< std::string, unsigned int > :: pair(
			           name, index2string. size( )));
      index = index2string. size( ); 
      index2string. push_back( name );
   }
}


unsigned int atom::make_index( ) const
{
   return index;
}


const std::string& atom::getstring( ) const
{
   return index2string [ index ];
}


bool atom::operator == ( atom at ) const 
{
   return index == at. index; 
}


bool atom::operator != ( atom at ) const 
{
   return index != at. index; 
}


bool atom::operator < ( atom at ) const
{
   return index < at. index;
}


std::ostream& operator << ( std::ostream& os, atom at )  
{
   os << at. getstring( ); 
   return os;
}


