

#ifndef ATOM_INCLUDED
#define ATOM_INCLUDED   1


#include <vector>
#include <map>
#include <iostream>

#include "atom.h"


class atom 
{
private: 
   unsigned int index;
      // Identifiers are normalized into unsigned int.

   static std::map< std::string, unsigned int > string2index;
   static std::vector< std::string > index2string;


public: 
   atom( const std::string& name );

   unsigned int make_index( ) const;
      // Maps the atom into a unique index.

   const std::string& getstring( ) const;
      // Gets the string that represents the atom.

   bool operator == ( atom at ) const;
   bool operator != ( atom at ) const; 
   bool operator < ( atom at ) const;

}; 


std::ostream& operator << ( std::ostream& stream, atom at );


#endif



