

#include "interpretation.h"



void interpretation::assign( atom a, bool b ) 
{
   repr [a] = b;
}


void interpretation::remove( atom a ) 
{
   repr. erase(a);
}


bool interpretation::value( atom a ) const 
{
   std::map< atom, bool > :: const_iterator p = repr. find(a);
   ASSERT( p != repr. end( ));
   return p -> second;
}


bool interpretation::isdefined( atom a ) const
{
   std::map< atom, bool > :: const_iterator p = repr. find(a);
   return p != repr. end( );
}


std::ostream& operator << ( std::ostream& stream, 
		            const interpretation& i )
{
   stream << "Interpretation:\n\n";
   for( std::map< atom, bool > :: const_iterator p = i. repr. begin( );
           p != i. repr. end( );
	   ++ p )
   {
      stream << "I( " << ( p -> first ) << " ) = ";
      if( p -> second )
         stream << "true\n";
      else
         stream << "false\n";
   }
   stream << "\n";
   return stream;
}


